package com.ejie.ab61.model.solicitudes;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import java.sql.Clob;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * MensajesSolicitud  
 * 
 *  
 */

public class MensajesSolicitud implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idMensaje;
	private String tipomensaje;
	private Clob mensaje;
	private Date fechaRegistro;
	private String codProcedureId;
	private String plateaType;
	private String plateaSubtype;
	private String ficheroMensaje;

	private List<Solicitudes> solicitudeses = new ArrayList<Solicitudes>();

	/**
	 * Method 'MensajesSolicitud'.
	 */
	public MensajesSolicitud() {
	}

	/**
	 * Method 'MensajesSolicitud'.
	 * 
	 * @param idMensaje
	 *            Integer
	 */
	public MensajesSolicitud(Integer idMensaje) {
		this.idMensaje = idMensaje;
	}

	/**
	 * Method 'MensajesSolicitud'.
	 * 
	 * @param idMensaje
	 *            Integer
	 * @param codmensaje
	 *            String
	 * @param tipomensaje
	 *            String
	 * @param mensaje
	 *            Clob
	 * @param fechaRegistro
	 *            Date
	 */
	public MensajesSolicitud(Integer idMensaje, String tipomensaje, Clob mensaje, Date fechaRegistro) {
		this.idMensaje = idMensaje;
		this.tipomensaje = tipomensaje;
		this.mensaje = mensaje;
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'MensajesSolicitud'.
	 * 
	 * @param idMensaje
	 *            Integer
	 * @param codmensaje
	 *            String
	 * @param tipomensaje
	 *            String
	 * @param mensaje
	 *            Clob
	 * @param fechaRegistro
	 *            Date
	 * @param solicitudeses
	 *            List<Solicitudes>
	 */
	public MensajesSolicitud(Integer idMensaje, String tipomensaje, Clob mensaje, Date fechaRegistro,
			List<Solicitudes> solicitudeses) {

		this.idMensaje = idMensaje;
		this.tipomensaje = tipomensaje;
		this.mensaje = mensaje;
		this.fechaRegistro = fechaRegistro;
		this.solicitudeses = solicitudeses;
	}

	/**
	 * Method 'getIdMensaje'.
	 *
	 * @return Integer
	 */

	public Integer getIdMensaje() {
		return this.idMensaje;
	}

	/**
	 * Method 'setIdMensaje'.
	 *
	 * @param idMensaje
	 *            Integer
	 * @return
	 */

	public void setIdMensaje(Integer idMensaje) {
		this.idMensaje = idMensaje;
	}

	/**
	 * Method 'getTipomensaje'.
	 *
	 * @return String
	 */

	public String getTipomensaje() {
		return this.tipomensaje;
	}

	/**
	 * Method 'setTipomensaje'.
	 *
	 * @param tipomensaje
	 *            String
	 * @return
	 */

	public void setTipomensaje(String tipomensaje) {
		this.tipomensaje = tipomensaje;
	}

	/**
	 * Method 'getMensaje'.
	 *
	 * @return Clob
	 */
	@JsonIgnore

	public Clob getMensaje() {
		return this.mensaje;
	}

	/**
	 * Method 'setMensaje'.
	 *
	 * @param mensaje
	 *            Clob
	 * @return
	 */

	public void setMensaje(Clob mensaje) {
		this.mensaje = mensaje;
	}

	/**
	 * @return the codProcedureId
	 */
	public String getCodProcedureId() {
		return codProcedureId;
	}

	/**
	 * @param codProcedureId
	 *            the codProcedureId to set
	 */
	public void setCodProcedureId(String codProcedureId) {
		this.codProcedureId = codProcedureId;
	}

	/**
	 * @return the plateaType
	 */
	public String getPlateaType() {
		return plateaType;
	}

	/**
	 * @param plateaType
	 *            the plateaType to set
	 */
	public void setPlateaType(String plateaType) {
		this.plateaType = plateaType;
	}

	/**
	 * @return the plateaSubtype
	 */
	public String getPlateaSubtype() {
		return plateaSubtype;
	}

	/**
	 * @param plateaSubtype
	 *            the plateaSubtype to set
	 */
	public void setPlateaSubtype(String plateaSubtype) {
		this.plateaSubtype = plateaSubtype;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getSolicitudeses'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<Solicitudes> getSolicitudeses() {
		return this.solicitudeses;
	}

	/**
	 * Method 'setSolicitudeses'.
	 *
	 * @param solicitudeses
	 *            List
	 * @return
	 */
	public void setSolicitudeses(List<Solicitudes> solicitudeses) {
		this.solicitudeses = solicitudeses;
	}

	/**
	 * @return the ficheroMensaje
	 */
	public String getFicheroMensaje() {
		return ficheroMensaje;
	}

	/**
	 * @param ficheroMensaje
	 *            the ficheroMensaje to set
	 */
	public void setFicheroMensaje(String ficheroMensaje) {
		this.ficheroMensaje = ficheroMensaje;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idMensaje: ").append(this.idMensaje).append(" ]");
		result.append(", [ tipomensaje: ").append(this.tipomensaje).append(" ]");
		result.append(", [ plateaType: ").append(this.plateaType).append(" ]");
		result.append(", [ plateaSubtype: ").append(this.plateaSubtype).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
